/*
Copyright (C) Mohammad Mazarei  Zeus@Sisoog.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
02111-1307, USA.
*/

#include "stm32f10x_dac.h"



#define AudioBuffer_Size      4608
extern s16 AudioBuffer[AudioBuffer_Size];

typedef enum { FULL=0,LOW_EMPTY=1,HIGH_EMPTY=2 }                AUDIO_PlaybackBuffer_Status ;
typedef enum { MONO, STEREO}                                    AUDIO_Format_enum;
typedef enum { NO_SOUND, IS_PLAYING }                           AUDIO_Playback_status_enum;
typedef enum { LG_8_BITS=8, LG_16_BITS=16}  AUDIO_Length_enum;

extern  volatile AUDIO_PlaybackBuffer_Status  audio_buffer_fill;

void init_dac(void);
void DAC_Set_Reat(int frq);

void DAC_START(void);
void DAC_PAUSE(void);
void DAC_STOP(void);

void DAC_DMA_INIT(uint32_t *buffer,int size,char num_ch,char BitsPerSample);

AUDIO_PlaybackBuffer_Status AUDIO_PlaybackBuffer_GetStatus(AUDIO_PlaybackBuffer_Status value);

