#include <stdint.h>
#include "sd_spi.h"
#include "diskio.h"
#include "stm32f10x_spi.h"

DSTATUS disk_initialize (BYTE drv)
{
	if(drv)	 return(STA_NOINIT);
	if(sdCardInit()==1) return(RES_OK); else return(STA_NOINIT);
	
}


DSTATUS disk_shutdown (BYTE drv)
{
	if(drv)	 return(RES_PARERR);
	return(RES_OK);
}


DSTATUS disk_status (BYTE drv)
{
	if(drv)	 return(RES_PARERR);
	return(RES_OK);
}


DRESULT disk_read (BYTE drv,BYTE* buf, DWORD lba, BYTE count)
{
	if(drv)	 return(RES_PARERR);
	if(sdReadBlocks(lba,count,buf)==1) return(RES_OK); else return(RES_ERROR);
}


DRESULT disk_write (BYTE drv,const BYTE* buf, DWORD lba, BYTE count)
{
	if(drv)	 return(RES_PARERR);
	if(sdWriteBlocks(lba,count,(uint8_t*)buf)==1) return(RES_OK); else return(RES_ERROR);
}

DRESULT disk_ioctl (
	BYTE drv,		/* Physical drive nmuber (0) */
	BYTE ctrl,		/* Control code */
	void *buff		/* Buffer to send/receive control data */
)
{

    long nb;
	 uint16_t bs;

	 sdGetSizeInfo((uint32_t*)&nb,  &bs);
	if (drv) return RES_PARERR;
  

	switch (ctrl) 
	{
	  case CTRL_SYNC :
	      
		return RES_OK;

	  case GET_SECTOR_COUNT : 
	    *(DWORD*)buff = nb;
	    return RES_OK;

	  case GET_BLOCK_SIZE :
	    *(WORD*)buff = bs;
	    return RES_OK;	

	  case CTRL_POWER :

		return RES_OK;

	  case CTRL_LOCK :
		return RES_OK;

	  case CTRL_EJECT :
		return RES_OK;

      /* MMC/SDC command */
	  case MMC_GET_TYPE :
		break;

	  case MMC_GET_CSD :
		break;

	  case MMC_GET_CID :
		break;

	  case MMC_GET_OCR :
		break;

	  case MMC_GET_SDSTAT :
		break;	
	}
	return RES_PARERR;  
}



