/*
Copyright (C) Mohammad Mazarei  Zeus@Sisoog.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
02111-1307, USA.
*/

#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_usart.h"
#include "stm32f10x_spi.h"
#include "stm32f10x_tim.h"
#include "misc.h"
#include "init_sys.h"

void RCC_Configuration(void)
{   
  /* Enable peripheral clocks ------------------------------------------------*/
  /* DMA2 clock enable */
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA2, ENABLE);
  /* GPIOA Periph clock enable */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE);
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);
}


void GPIO_Configuration(void){
 GPIO_InitTypeDef GPIO_InitStructure;
   // GPIO Init
  // Enable GPIO clock and release reset
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         ENABLE);
  RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         DISABLE);

  // Assign B1
	
// 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
//   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
//   GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_2;                              
//   GPIO_Init(GPIOA, &GPIO_InitStructure);
// 	
// 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
//   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
//   GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_3;
//                                 
//   GPIO_Init(GPIOA, &GPIO_InitStructure);
// 	
// 	  /* Configure USARTy TX and USARTy CK pins as alternate function push-pull */
//   GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2 ;
//   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
//   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
//   GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	
	
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_8 | GPIO_Pin_9;
                                
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  
	
	
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_7;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIOB->BSRR=(1<<7);   // Set Status BackLight
	
	
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3;
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	
	// BOARD LED
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_8;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIOA->BSRR=(1<<8);   // Set Status BackLight
	
}




void NVIC_Configuration(void) 
{ 
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);           /* Place the vector table into FLASH */ 		
} 









void mmc_spi_init(void){
		
	GPIO_InitTypeDef  GPIO_InitStructure;
	  SPI_InitTypeDef  SPI_InitStructure;
	
	
		/* Enable GPIO clock for SD_CS */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
	
	/* Configure SPI pins: SCK and MOSI with default alternate function (not remapped) push-pull */
	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_MMC_SCK | GPIO_Pin_MMC_MOSI ;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;
	GPIO_Init(GPIO_MMC, &GPIO_InitStructure);

	/* Configure MISO as Input with internal pull-up */
	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_MMC_MISO;
	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IPU;
	GPIO_Init(GPIO_MMC, &GPIO_InitStructure);	 

	
	/* Configure SD_CS pin */	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_MMC_CS; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIO_MMC, &GPIO_InitStructure);
	
	
	/* Enable SPI2 Periph clock */ 
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2,ENABLE);
  
	
// 	/* SPI2 configuration */
// 	SPI_StructInit(&SPI_InitStructure); 
// 	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
// 	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
// 	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
// 	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
// 	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
// 	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
// 	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256; // 72000kHz/256=281kHz < 400kHz
// 	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
// 	SPI_InitStructure.SPI_CRCPolynomial = 7;


	
	
		  /* SPI1 configuration */   
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;   
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;   
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;   
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;   
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;   
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;   
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;   
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;   
  SPI_InitStructure.SPI_CRCPolynomial = 7;   
  SPI_Init(SPI2, &SPI_InitStructure); 
	
	SPI_CalculateCRC(SPI2, DISABLE);
	
	SPI_Cmd(SPI2, ENABLE);
		
}



void SPI_SPEED_UP(void){
  SPI_InitTypeDef  SPI_InitStructure;
 	/* Enable SPI2 Periph clock */ 
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2,ENABLE);
  
	
 
	
// 	/* SPI2 configuration */
// 	SPI_StructInit(&SPI_InitStructure); 
// 	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
// 	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
// 	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
// 	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
// 	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
// 	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
// 	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2; // 72000kHz/2= 36000 kHz 
// 	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
// 	SPI_InitStructure.SPI_CRCPolynomial = 7;
	
			  /* SPI1 configuration */   
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;   
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;   
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;   
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;   
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;   
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;   
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;   
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;   
  SPI_InitStructure.SPI_CRCPolynomial = 7;   
  SPI_Init(SPI2, &SPI_InitStructure); 

	SPI_Init(SPI2, &SPI_InitStructure);
	SPI_CalculateCRC(SPI2, DISABLE);
	SPI_Cmd(SPI2, ENABLE); 
}


char SPI(char dat)
{
	
	//MMC_Select();
	SPI_I2S_SendData(SPI2, dat);
	/* Wait to receive a byte */
	while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET) { ; }
  //MMC_Deselect();
	/* Return the byte read from the SPI bus */
	return SPI_I2S_ReceiveData(SPI2);

}




void TIM1_Configuration(long Tm_us){// Max 6000000 /min 1
  
	int Prescaler ,Period;
	
	
	NVIC_InitTypeDef NVIC_InitStructure;
  TIM_TimeBaseInitTypeDef TIM1_TimeBaseInitStruct;
  
    // Timer1 Init
  // Enable Timer1 clock and release reset
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1,ENABLE);
  RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM1,DISABLE);
  
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);
  
  
  if(Tm_us >6000 ){ 
    Prescaler = 7200; // For 100 us 
    Period =  Tm_us / 100; 
  }else{
    Prescaler = 72; // For 1us
    Period = Tm_us; 
  }
  // Set timer period 0.1 sec
  TIM1_TimeBaseInitStruct.TIM_Prescaler = Prescaler;  // 72 For 1us resolution
  TIM1_TimeBaseInitStruct.TIM_CounterMode = TIM_CounterMode_Up;
  TIM1_TimeBaseInitStruct.TIM_Period = Period;  // 100 For 1 ms
  TIM1_TimeBaseInitStruct.TIM_ClockDivision = TIM_CKD_DIV1;
  TIM1_TimeBaseInitStruct.TIM_RepetitionCounter = 0;
  TIM_TimeBaseInit(TIM1,&TIM1_TimeBaseInitStruct);

  // Clear update interrupt bit
  TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
  // Enable update interrupt
  TIM_ITConfig(TIM1,TIM_FLAG_Update,ENABLE);

  NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 7;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  // Enable timer counting
  TIM_Cmd(TIM1,ENABLE);
  
}
