/*
Copyright (C) Mohammad Mazarei  Zeus@Sisoog.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
02111-1307, USA.
*/

#include <stdio.h>
#include "STM32F10x.h"
#include "Uart.h"
#include "init_sys.h"
#include "ff.h"
#include "diskio.h"
#include "dac.h"
#include "mp3.h"


FATFS fs;			/* File system object */
/**********************************************/
#define SET_LED()				GPIOA->BSRR=(1<<8)
#define RESET_LED()			GPIOA->BRR=(1<<8)

void NVIC_Configuration(void);




int  main(void){
	
	RCC_Configuration();										
	GPIO_Configuration();
	NVIC_Configuration();
	buffer_Init();                          /* Uart init RX / TX buffers             */
  USART1_Init();
	
	while(disk_initialize(0)==STA_NOINIT)		/*Init SdCard Disk*/
	{
		SET_LED();
	}RESET_LED(); 

	while(f_mount(0,&fs)!=RES_OK)					/*Mount Fat File System*/
	{
		SET_LED();
	}RESET_LED();
	

	printf("Zeus@sisoog.com\r\n");
	MP3_PlayAudioFile("start.mp3"); /*Play Mp3 File*/
	play_wave("start.wav");				  /*Play Wave File*/
	
	
	while(1)
	{

 	}
	

}
